
#include "Alignment.h"
#include <iostream>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

using namespace std;

int main(int argc, char* argv[])
{

	cout << argv[1] << endl;
	double aa = 0.0001, bb = 0, cc = 1;
	int it = 1;
	int rr = 0;
	int pp = 0;
	int nn = 1;
	char* name1;
	char* name2;

	try
	{
		for( int i = 1; i < argc; i++)
		{
			if( i == 1 )
			{
				name1 = argv[ i ];
			}
			else if( i == 2 )
			{
				name2 = argv[ i ];
			}
			else if ( ( strlen(argv[i]) == 2 ) && ( argv[i][0]=='-' ) && ( argv[i][1]=='a' || argv[i][1]=='b' || argv[i][1]=='c' || argv[i][1]=='i' ||argv[i][1]=='r' ||argv[i][1]=='n') && ( i + 1 < argc) )
			{
				i++;
				if( argv[i-1][1]=='a' )
				{
					aa = atof(argv[i]);
					if( aa <0 || aa > 1)
					{
						cout << "Error : value of a must be between 0 and 1 :" << endl;
						return -1;
					}
				}
				else if( argv[i-1][1]=='b' )
				{
					bb = atof(argv[i]);
					if( bb <0 || bb > 1)
					{
						cout << "Error : value of b must be between 0 and 1 :" << endl;
						return -1;
					}
				}
				else if( argv[i-1][1]=='c' )
				{
					cc = atof(argv[i]);
					if( cc <0 || cc > 1)
					{
						cout << "Error : value of c must be between 0 and 1 :" << endl;
						return -1;
					}
				}
				else if( argv[i-1][1]=='n' )
				{
					nn = atoi(argv[i]);
				}
				else if( argv[i-1][1]=='r' )
				{
					rr = atoi(argv[i]);
					i++;
					pp = atoi(argv[i]);
				}
				else
				{
					it = atoi(argv[i]);
					if( it < 0 )
					{
						cout << "Error : value of i must be positive" << endl;
						return -1;
					}
				}
			}
			else
			{
				cout << "Error in argument : " << argv[i] << endl;
				return -1;
			}
		}


		cout << "=================================================" << endl;
		cout << "Network 1 : " << name1 << endl;
		cout << "Network 2 : " << name2 << endl;
		cout << "a = " << aa << endl;
		cout << "b = " << bb << endl;
		cout << "c = " << cc << endl;
		cout << "i = " << it << endl;
		cout << "=================================================" << endl;


		Network network1(name1);
		Network network2(name2);

		bool reverse = false;

		if( network1.size > network2.size)
			reverse = true;

		int edgeNum = 0;

		int CCCV = 0,CCCE = 0;
		float EC = 0, NC = 0, IC = 0;


		stringstream strm;

		strm << name1 << "-" << name2;
		if( rr > 0 )
			strm << rr << "r" << pp;
		strm << "-a" << aa << "-b" << bb << "-c" << cc << "-i" << it;


		edgeNum = pp * network2.numOfEdge / 100;

		if( rr == 1)
		{
			network2.randomEdgeRemoval( edgeNum );
		}
		else if(rr == 2)
		{
			network2.randomEdgeAddition( edgeNum );
		}
		else if(rr == 3)
		{
			network2.randomEdgeRemoval( edgeNum );
			network2.randomEdgeAddition( edgeNum );
		}


		Alignment alignment( network1, network2 );

		alignment.setSimilarities(it, bb, cc);

		alignment.align(aa);

		CCCV += alignment.CCCV;
		CCCE += alignment.CCCE;
		EC += alignment.EC;
		NC += alignment.NC;
		IC += alignment.IC;

		alignment.outputEvaluation(strm.str());
		alignment.outputAlignment(strm.str());



		//alignment.SAalign(aa, 200);
	//	alignment.improve(aa);
		for( int i = 1; i < nn; i++ )
		{

			cout << "##################    " << i << endl;
			Network network2(name2);
			edgeNum = pp * network2.numOfEdge / 100;

			if( rr == 1)
			{
				network2.randomEdgeRemoval( edgeNum );
			}
			else if(rr == 2)
			{
				network2.randomEdgeAddition( edgeNum );
			}
			else if(rr == 3)
			{
				network2.randomEdgeRemoval( edgeNum );
				network2.randomEdgeAddition( edgeNum );
			}


			Alignment alignment( network1, network2 );

			alignment.setSimilarities(it, bb, cc);

			alignment.align(aa);

			CCCV += alignment.CCCV;
			CCCE += alignment.CCCE;
			EC += alignment.EC;
			NC += alignment.NC;
			IC += alignment.IC;

			alignment.outputEvaluation(strm.str());
			alignment.outputAlignment(strm.str());
		}

		if( nn > 1)
		{
			cout << "######################### THIS IS TOTAL#########################" << endl;
			cout << "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" << endl;
			cout << "*** CONNECTED COMPONENTS SIZE : " << endl;
			cout << "Nodes = " << CCCV/nn << endl;
			cout << "Edges = " << CCCE/nn << endl;

			cout << "===============================================================" << endl;
			if(reverse)
			{
				cout << "G1:  Nodes : " << network2.size << "  - Edges : " << network2.numOfEdge << endl;
				cout << "G2:  Nodes : " << network1.size << "  - Edges : " << network1.numOfEdge << endl;
			}
			else
			{
				cout << "G1:  Nodes : " << network1.size << "  - Edges : " << network1.numOfEdge << endl;
				cout << "G2:  Nodes : " << network2.size << "  - Edges : " << network2.numOfEdge << endl;
			}

			cout << "EC : " << EC/nn << endl;
			cout << "NC : " << NC/nn << endl;
			cout << "IC : " << IC/nn << endl;



			string outFile = strm.str();
			outFile.append(".eval");
			ofstream outputFile( outFile.c_str());



			outputFile << "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" << endl;
			outputFile << "*** CONNECTED COMPONENTS SIZE : " << endl;
			outputFile << "Nodes = " << CCCV/nn << endl;
			outputFile << "Edges = " << CCCE/nn << endl;

			outputFile << "===============================================================" << endl;
			if(reverse)
			{
				outputFile << "G1:  Nodes : " << network2.size << "  - Edges : " << network2.numOfEdge << endl;
				outputFile << "G2:  Nodes : " << network1.size << "  - Edges : " << network1.numOfEdge << endl;
			}
			else
			{
				outputFile << "G1:  Nodes : " << network1.size << "  - Edges : " << network1.numOfEdge << endl;
				outputFile << "G2:  Nodes : " << network2.size << "  - Edges : " << network2.numOfEdge << endl;
			}

			outputFile << "EC : " << EC/nn << endl;
			outputFile << "NC : " << NC/nn << endl;
			outputFile << "IC : " << IC/nn << endl;
		}



	/*	double cnt = 1;
		while(cnt>0.00000001)
		{
			cout << "Enter aa : " << endl;
			cin >> aa;

			cout << "Enter bb : " << endl;
			cin >> bb;

			alignment.align(aa);
			cout << "Continue? (1=YES, 0=NO)" << endl;
			cin >> cnt;
		}*/

	}
	catch( exception &e)
	{
		cout << "Error in arguments!" << endl;
		e.what();
		return -1;
	}

	//cout << network1.getName( 0 );



	cout << endl;

	return 0;
}



